unit ThFortFunc;

interface

uses
  Classes, Math,  Graphics, SysUtils, OpenML;
const
  _FuncRoots              = 1;
  _FuncDiffRoots          = 2;
  _FuncExcessRoots        = 3;
  _FuncExcessDiffRoots    = 4;

type TFloat = extended;
type TIntegType = Integer;

TFunction = function(x: TFloat): TFloat;

type
  TThFortFunc = class(TThread)
  private
    Result: TFloat;
  protected
    procedure Execute; override;

  public
    constructor Create(FCOP:String; reg: String; X: TFloat);
    property terminated;
    //function  _Root: TFloat;
    //function  _Sum1: TFloat;
    //function  _Sum2: TFloat;
  end;

  procedure RefReshInitRootData;

var
 F_COP, I_reg: String;
 //Func: TFunction;
 I_X: TFloat;
 Error: Boolean;
 an,bn: array [1..15] of TFloat;
 P_Integral,P_IntegralMulti: Integer;
 MathProc: TMathLib;
 C_ScanStep,C_DistR,C_EpsF,C_EpsFNR,C_EpsDX,C_SafeLoop: TFloat;





implementation
uses UMHCFS;





constructor TThFortFunc.Create(FCOP:String; reg: String; X: TFloat);
begin
inherited Create(False);
MathProc:=TMathLib.Create;
Result:=0;
F_COP:=FCOP;
//Func:=FortFunc1;
I_X:=X;
I_reg:=Copy(reg,1,1);
Error:=False;
{
C_ScanStep:=0.001; //=DistR
C_EpsDX:=1E-17;
C_EpsFNR:=1E-12;
C_EpsF:=1E-7;
C_DistR:=0.001; //= h - ScanStep !
C_SafeLoop:=500;
C_ScanStep:=0.001;
P_Integral:=100;
P_IntegralMulti:=30;

}


 C_ScanStep:=Form1.C_ScanStep;  //0.001; =DistR
 C_EpsDX:=Form1.C_EpsDX;//1E-17;
 C_EpsFNR:=Form1.C_EpsFNR;//1E-12;
 C_EpsF:=Form1.C_EpsF;//1E-7;
 C_DistR:=Form1.C_ScanStep; //= h - ScanStep !
 C_SafeLoop:=Form1.C_SafeLoop;//500;
 P_Integral:=Form1.P_Integral;//100;
 P_IntegralMulti:=Form1.P_IntegralMulti;//30;


RefReshInitRootData;

//Init;
end;


procedure RefReshInitRootData;
begin
  //C_ScanStep:=0.001; //=DistR
  MathProc.SetMode(ml_Root_ScanStep,C_ScanStep);

  //C_EpsDX:=1E-17;
  MathProc.SetMode(ml_RootBisection_Currency,C_EpsDX);

  //C_EpsFNR:=1E-12;
  MathProc.SetMode(ml_RootNR_Currency,C_EpsFNR);

  //C_EpsF:=1E-7;
  MathProc.SetMode(ml_Root_Currency_Total,C_EpsF);

  //C_DistR:=0.001; //= h - ScanStep !
  MathProc.SetMode(ml_Root_MinDistant,C_DistR);

  //C_SafeLoop:=500;
  MathProc.SetMode(ml_Root_Safe_Loop,C_SafeLoop);
end;


procedure ReadInitRootData;
begin
  if (Form1.F_ES > 0) and ((Form1.F_ES) <= 0.1) then C_ScanStep:=(Form1.F_ES);
  if (Form1.F_E > 0) and ((Form1.F_E) <= 0.1) then C_EpsFNR:=(Form1.F_E);
  if (Form1.F_EB > 0) and ((Form1.F_EB) <= 0.1) then C_EpsDX:=(Form1.F_EB);
end;


procedure WriteRootData;
begin
  if (Form1.F_ES > 0) and ((Form1.F_ES) <= 0.1) then C_ScanStep:=(Form1.F_ES);
  if (Form1.F_E > 0) and ((Form1.F_E) <= 0.1) then C_EpsFNR:=(Form1.F_E);
  if (Form1.F_EB > 0) and ((Form1.F_EB) <= 0.1) then C_EpsDX:=(Form1.F_EB);

  Form1.C_ScanStep:=C_ScanStep;
  Form1.C_EpsDX:=C_EpsDX;
  Form1.C_EpsFNR:=C_EpsFNR;
  {
  Form1.C_EpsF:=C_EpsF;
  Form1.C_DistR:=C_DistR;
  Form1.C_SafeLoop:=C_SafeLoop;
  }
end;



(*
procedure excessFuncD(var MX: TArrayF; var E: Integer);   //root[(1/f')]
var
h: extended;
begin
MathProc.SetMode(ml_DerivativeMode,ml_External);
MathProc.SetMode(ml_Derivative1Adr,Cardinal(Form1.C_IFD1FuncD));
MathProc.SetMode(ml_Derivative2Adr,Cardinal(Form1.C_IFD2FuncD));
if (Form1.F_F <> 0) and (abs(Form1.F_F) <= 0.1) then h:=abs(Form1.F_F) else h:=0.01;//0.001
MX:=MathProc.ScanRoot{Extr}(TAddress(Form1.C_IFFuncD),@Form1.V_X,Form1.F_A,Form1.F_B,h,E,TAddress(Form1.C_D1Func));
MathProc.SetMode(ml_DerivativeMode,ml_Internal);
end;

procedure excessFunc(var MX: TArrayF; var E: Integer);   //root[(1/f)]
var
h: extended;
begin
MathProc.SetMode(ml_DerivativeMode,ml_External);
MathProc.SetMode(ml_Derivative1Adr,Cardinal(Form1.C_IFD1Func));
MathProc.SetMode(ml_Derivative2Adr,Cardinal(Form1.C_IFD2Func));
if (Form1.F_F <> 0) and (abs(Form1.F_F) <= 0.1) then h:=abs(Form1.F_F) else h:=0.01;//0.001
MX:=MathProc.ScanRoot{Extr}(TAddress(Form1.C_IFFunc),@Form1.V_X,Form1.F_A,Form1.F_B,h,E,TAddress(Form1.C_Func));
MathProc.SetMode(ml_DerivativeMode,ml_Internal);
end;

procedure extremFunc(var MX: TArrayF; var E: Integer);   //root[(f)']
var
h: extended;
begin
  MathProc.SetMode(ml_DerivativeMode,ml_External);
  MathProc.SetMode(ml_Derivative1Adr,Cardinal(Form1.C_D2Func));
  MathProc.SetMode(ml_Derivative2Adr,Cardinal(Form1.C_D3Func));
  if (Form1.F_F <> 0) and (abs(Form1.F_F) <= 0.1) then h:=abs(Form1.F_F) else h:=0.01;//0.001
  MX:=MathProc.ScanRoot{Extr}(TAddress(Form1.C_D1Func),@Form1.V_X,Form1.F_A,Form1.F_B,h,E);
  MathProc.SetMode(ml_DerivativeMode,ml_Internal);
end;
*)

procedure Roots(Mode: Cardinal; var MX: TArrayF; var E: Integer );
var
h: extended;
begin
  MathProc.SetMode(ml_DerivativeMode,ml_External);

  case Mode of
     _FuncRoots:
          begin
             MathProc.SetExtAddr(ml_Derivative1Adr,Cardinal(Form1.C_D1Func));
             MathProc.SetExtAddr(ml_Derivative2Adr,Cardinal(Form1.C_D2Func));
          end;
     _FuncDiffRoots:
          begin
             MathProc.SetExtAddr(ml_Derivative1Adr,Cardinal(Form1.C_D2Func));
             MathProc.SetExtAddr(ml_Derivative2Adr,Cardinal(Form1.C_D3Func));
          end;
     _FuncExcessRoots:
          begin
             MathProc.SetExtAddr(ml_Derivative1Adr,Cardinal(Form1.C_IFD1Func));
             MathProc.SetExtAddr(ml_Derivative2Adr,Cardinal(Form1.C_IFD2Func));
          end;
      _FuncExcessDiffRoots:
          begin
            MathProc.SetExtAddr(ml_Derivative1Adr,Cardinal(Form1.C_IFD1FuncD));
            MathProc.SetExtAddr(ml_Derivative2Adr,Cardinal(Form1.C_IFD2FuncD));
          end;

  end;


  ReadInitRootData;
  RefReshInitRootData;
  WriteRootData;

  case Mode of
     _FuncRoots:
          MX:=MathProc.ScanRoot(TAddress(Form1.C_Func),@Form1.V_X,Form1.F_A,Form1.F_B,E);
     _FuncDiffRoots:
          MX:=MathProc.ScanRoot(TAddress(Form1.C_D1Func),@Form1.V_X,Form1.F_A,Form1.F_B,E);
     _FuncExcessRoots:
          MX:=MathProc.ScanRoot(TAddress(Form1.C_IFFunc),@Form1.V_X,Form1.F_A,Form1.F_B,E,TAddress(Form1.C_Func));
     _FuncExcessDiffRoots:
          MX:=MathProc.ScanRoot(TAddress(Form1.C_IFFuncD),@Form1.V_X,Form1.F_A,Form1.F_B,E,TAddress(Form1.C_D1Func));
  end;

  MathProc.SetMode(ml_DerivativeMode,ml_Internal);
end;


procedure FuncRoots(var MX: TArrayF; var E: Integer);   //root[f]
var
h: extended;
begin
  MathProc.SetMode(ml_DerivativeMode,ml_External);
  MathProc.SetExtAddr(ml_Derivative1Adr,Cardinal(Form1.C_D1Func));
  MathProc.SetExtAddr(ml_Derivative2Adr,Cardinal(Form1.C_D2Func));
  ReadInitRootData; RefReshInitRootData;
  MX:=MathProc.ScanRoot(TAddress(Form1.C_Func),@Form1.V_X,Form1.F_A,Form1.F_B,E);
  MathProc.SetMode(ml_DerivativeMode,ml_Internal);
end;






procedure convFunc(var MX: TArrayF; var E: Integer);    // 
var
i,n,L,K,m1,m2,L1,j: Integer;
MX1: TArrayF;
h,sf: extended;
PF: PFloatType;
F: TFloatType;
begin
//extremFunc(MX1,E);
Roots(_FuncDiffRoots,MX1, E);
L:=Length(MX1);
  if (E = 0)  then
  begin
   PF:=@Form1.V_X;
   L:=Length(MX1)-1;
   L1:=0; j:=1;  //SetLength(MX,1);
   if L >= 0 then
   begin
     for i:=1 to L do
     begin
      PF^:=MX1[i];
      F:=CalcFunc(Cardinal(Form1.C_D2Func));
      if F < 0 then begin SetLength(MX,Length(MX)+1); MX[High(MX)]:=MX1[i]; inc(L1); inc(j); end;
     end;
   end;
  end
end;



procedure concFunc(var MX: TArrayF; var E: Integer);    // 
var
i,n,L,K,m1,m2,L1,j: Integer;
MX1: TArrayF;
h,sf: extended;
PF: PFloatType;
F: TFloatType;
begin
//extremFunc(MX1,E);
Roots(_FuncDiffRoots,MX1, E);
L:=Length(MX1);
  if (E = 0)  then
  begin
   PF:=@Form1.V_X;
   L:=Length(MX1)-1;
   L1:=0; j:=1;  //SetLength(MX,1);
   if L >= 0 then
   begin
     for i:=1 to L do
     begin
      PF^:=MX1[i];
      F:=CalcFunc(Cardinal(Form1.C_D2Func));
      if F > 0 then begin SetLength(MX,Length(MX)+1); MX[High(MX)]:=MX1[i]; inc(L1); inc(j); end;
     end;
   end;
  end
end;


procedure rootIFext; //root[(1/f)']
var
E,i,n,L,K,m1,m2,L1,j: Integer;
MX,MY: TArrayF;
h,sf: extended;
PV: TArrayPF;
IV: TArrayPI;
MCF,FuncN: TArrayA;
CF,HCF: Pointer;
x1,x2,x: TFloat;
BH: Boolean;
SH: String;
AI,BI: TArrayI;
PF: PFloatType;
F,f1,f2,max,maxf,min,minf: TFloatType;
begin
  MathProc.SetMode(ml_DerivativeMode,ml_External);
  MathProc.SetMode(ml_Derivative1Adr,Cardinal(Form1.C_IFD1Func));
  MathProc.SetMode(ml_Derivative2Adr,Cardinal(Form1.C_IFD2Func));
  ReadInitRootData; RefReshInitRootData;
  MX:=MathProc.ScanRoot(TAddress(Form1.C_IFFunc),@Form1.V_X,Form1.F_A,Form1.F_B,E,TAddress(Form1.C_IFD1Func));
  MathProc.SetMode(ml_DerivativeMode,ml_Internal);
  L:=Length(MX);
  if (E = 0) and (L <= UMHCFS.DRS) then
  begin
   L:=Length(MX)-1;
   if L >= 0 then
   begin
     for i:=1 to L do
     begin
      Form1.R_Xs[i-1]:=MX[i];
     end;
     Form1.CopyToRSD;
     Form1.StS.Caption:='Xs:'+IntToStr(L);
     Form1.LeRS:=L;
     Form1.cRS:=0;
   end;
  end
  else
  E:=1;
end;




procedure   ShowRoots(MX: TArrayF; E: Integer; var E1: Integer);
var
L,i,MaxOut: Integer;
begin
  E1:=E;
  L:=Length(MX);
  if (E = 0) {and (L <= UMHCFS.DRS)} then
  begin
   L:=Length(MX)-1;
   MaxOut:=L;
   if  MaxOut > UMHCFS.DRS then MaxOut:=UMHCFS.DRS;
   Form1.LeRS:=MaxOut;
   if L >= 1 then
   begin
     for i:=1 to MaxOut do
     begin
      Form1.R_Xs[i-1]:=MX[i];
     end;
     Form1.CopyToRSD;
     Form1.StS.Caption:='Xs:'+IntToStr(MaxOut);
     //Form1.LeRS:=L;
     Form1.cRS:=0;
     if (L > UMHCFS.DRS)then E1:=2;
   end
   else
   begin
     E1:=3// Not Found
   end;
  end
  else
  begin
    if L = 0 then E1:=3 //Not Found
    else
    E1:=1;
  end;

end;






procedure TThFortFunc.Execute;
label endp;
var
E,i,N,Nx,L,K,m1,m2,L1,j: Integer;
Er,Etr: Cardinal;
MX,MY: TArrayF;
h,sf: extended;
PV: TArrayPF;
IV: TArrayPI;
MCF,FuncN: TArrayA;
CF,HCF: Pointer;
x1,x2,x: TFloat;
BH: Boolean;
SH: String;
AI,BI: TArrayI;
PF: PFloatType;
F,f1,f2,max,maxf,min,minf: TFloatType;
begin
 E:=0;  Er:=0; Etr:=0; I_X:=Form1.R_X;
 //???:

 MathProc.SetMode(ml_Integral_Part,Form1.F_E);
 MathProc.SetMode(ml_Derivative_Currency,Form1.F_E);
 //MathProc.SetMode(ml_Root_Currency,Form1.F_E);
 MathProc.SetMode(ml_DiffEquation_Currency,Form1.F_E);
 //MathProc.SetMode(ml_RootType,Form1.F_D);
 //MathProc.SetMode(ml_E_SCRoot,Form1.F_G);
 MathProc.SetMode(ml_Diff_App,Form1.F_F);



 try
   if F_COP = 'DERIVATIVE1' then Result:=MathProc.Derivative1(TAddress(Form1.C_Func),@Form1.V_X,Form1.V_X) else
   if F_COP = 'DERIVATIVE2' then Result:=MathProc.Derivative2(TAddress(Form1.C_Func),@Form1.V_X,Form1.V_X) else
   if F_COP = 'ROOT1'       then
   begin
    MathProc.SetMode(ml_DerivativeMode,ml_External);
    MathProc.SetMode(ml_Derivative1Adr,Cardinal(Form1.C_D1Func));
    MathProc.SetMode(ml_Derivative2Adr,Cardinal(Form1.C_D2Func));
    Result:=MathProc.Root(TAddress(Form1.C_Func),@Form1.V_X,Form1.V_X,E);
    MathProc.SetMode(ml_DerivativeMode,ml_Internal);
   end
   else
   if F_COP = 'INTEGRAL1'   then
   begin
     if (Form1.F_E > 1) and (Trunc(Form1.F_E) = Form1.F_E) then P_Integral:=Trunc(Form1.F_E);
     MathProc.SetMode(ml_Integral_Part,P_Integral);
     Form1.P_Integral:=P_Integral;
     Result:=MathProc.Integral1(TAddress(Form1.C_Func),@Form1.V_X,Form1.F_A,Form1.F_B)
   end
   else
   if F_COP = 'INTEGRAL2'   then
   begin
     if (Form1.F_E > 1) and (Trunc(Form1.F_E) = Form1.F_E) then P_Integral:=Trunc(Form1.F_E);
     MathProc.SetMode(ml_Integral_Part,P_Integral);
     Form1.P_Integral:=P_Integral;
     Result:=MathProc.Integral2(TAddress(Form1.C_Func),@Form1.V_X,@Form1.V_Y,Form1.F_A,Form1.F_B,Form1.F_C,Form1.F_D)
   end
   else
   if F_COP = 'INTEGRAL3'   then
   begin
     if (Form1.F_E > 1) and (Trunc(Form1.F_E) = Form1.F_E) then P_Integral:=Trunc(Form1.F_E);
     MathProc.SetMode(ml_Integral_Part,P_Integral);
     Form1.P_Integral:=P_Integral;
     Result:=MathProc.Integral3(TAddress(Form1.C_Func),@Form1.V_X,@Form1.V_Y,@Form1.V_Z,Form1.F_A,Form1.F_B,Form1.F_C,Form1.F_D,Form1.F_F,Form1.F_G)
   end
   else

   if F_COP = 'INTEGRAL2F'  then Result:=MathProc.Integral2f(TAddress(Form1.C_Func),@Form1.V_X,@Form1.V_Y,Form1.F_A,Form1.F_B,TAddress(Form1.C_Func1),TAddress(Form1.C_Func2)) else
   if F_COP = 'INTEGRAL3F'  then Result:=MathProc.Integral3ff(TAddress(Form1.C_Func),@Form1.V_X,@Form1.V_Y,@Form1.V_Z,Form1.F_A,Form1.F_B,TAddress(Form1.C_Func1),TAddress(Form1.C_Func2),TAddress(Form1.C_Func3),TAddress(Form1.C_Func4)) else
   if F_COP = 'SUM1'        then Result:=MathProc.Sum1(TAddress(Form1.C_Func),@Form1.V_N,Trunc(Form1.F_A),Trunc(Form1.F_B)) else
   if F_COP = 'SUM2'        then Result:=MathProc.Sum2(TAddress(Form1.C_Func),@Form1.V_N,@Form1.V_K,Trunc(Form1.F_A),Trunc(Form1.F_B),Trunc(Form1.F_C),Trunc(Form1.F_D)) else
   if F_COP = 'SUM3'        then Result:=MathProc.Sum3(TAddress(Form1.C_Func),@Form1.V_N,@Form1.V_K,@Form1.V_M,Trunc(Form1.F_A),Trunc(Form1.F_B),Trunc(Form1.F_C),Trunc(Form1.F_D),Trunc(Form1.F_F),Trunc(Form1.F_G)) else
   if F_COP = 'INTEGRALSPLAIN3' then Result:= MathProc.IntegralSP(Form1.D_Ys,Form1.D_Xs,Form1.SplA,Form1.SplB) else
   if F_COP = 'DIFFEQ1'     then Result:=MathProc.DERK6(TAddress(Form1.C_Func),@Form1.V_X,@Form1.V_Y,Form1.R_Xs[0],Form1.R_Ys[0],Form1.V_X) else
 {if(F_COP = 'DIFFEQ2')    then
   begin
      n:=2;
      SetLength(MY,n);
      MY[0]:=Form1.R_Ys[0]; MY[1]:=Form1.R_Ys[1];
      SetLength(PV,n+1);
      PV[0]:=@Form1.V_X; PV[1]:=@Form1.V_Y; PV[2]:=@Form1.V_Y1;
      Result:=MathProc.DERK6N(TAddress(Form1.C_Func),PV,MY,Form1.R_Xs[0],Form1.V_X);
   end
   else}
   if(F_COP = 'DIFFEQN')    then
   begin


      n:=Form1.LeRSy;
      if (n <= 99) and (n > 0) then
      begin
        SetLength(MY,n);
        for I := 0 to n - 1 do
          begin
            MY[i]:=Form1.R_Ys[i];
          end;
        SetLength(PV,n+1);
        PV[0]:=@Form1.V_X;  PV[1]:=@Form1.V_Y;
        for I := 2 to n do
          begin
            PV[i]:=@Form1.V_YM[i-2];
          end;
      end;
      Result:=MathProc.DERK6N(TAddress(Form1.C_Func),PV,MY,Form1.R_Xs[0],Form1.V_X);
   end


   else
   if(F_COP = 'DIFFEQSYS1')    then
   begin
      //n:=Form1.LeFS;
      n:=Form1.LeRSy;
      if (Form1.LeFS < n) or (n < 2) then
      begin
        E:=4;
      end
      else
      begin
         SetLength(PV,n+1);  SetLength(FuncN,n);  SetLength(MY,n);
         PV[0]:=@Form1.V_X;
         for i := 0 to n - 1 do
         begin
          //PV[i+1]:=@Form1.V_YM[i];
          PV[i+1]:=@Form1.IntListVar[i].FloatVar;
          MY[i]:=Form1.R_Ys[i];
         end;
         for i := 0 to n-1 do
         begin
           Form1.ComplFunc(Form1.F_S[i],HCF,Er);
           if Er <> 0 then Etr:=1;
           FuncN[i]:=TAddress(HCF);
         end;

         if Etr = 0 then
         begin
          MathProc.DERK6Sys(FuncN,PV,MY,Form1.R_Xs[0],Form1.V_X,MX);
          for I := 0 to n-1 do
           begin
            Form1.R_Xs[i]:=MX[i];
           end;
          for i := 0 to n - 1 do
          begin
           Form1.FreeFunc(FuncN[i]);
          end;
          Form1.CopyToRSD;
          Form1.StS.Caption:='Xs:'+IntToStr(n);
          Form1.LeRS:=n;
          Form1.cRS:=0;
         end;

         Form1.RestoreSavedVarParam;
      end
   end

 else

 if F_COP = 'SCANROOT' then
 begin

  //FuncRoots(MX,E);
  Roots(_FuncRoots,MX,E);
  ShowRoots(MX,E,E);
 {
  L:=Length(MX);
  if (E = 0)then
  begin
   L:=Length(MX)-1;
   Form1.LeRS:=L;
   if L >= 1 then
   begin
     for i:=1 to L do
     begin
      Form1.R_Xs[i-1]:=MX[i];
     end;
     Form1.CopyToRSD;
     Form1.StS.Caption:='Xs:'+IntToStr(L);
     //Form1.LeRS:=L;
     Form1.cRS:=0;
     if (L > UMHCFS.DRS)then E:=2;
   end
   else
   begin
     E:=3// Not Found
   end;
  end
  else
  begin
    if L = 0 then E:=3 //Not Found
    else
    E:=1;
  end;
  }


 end
 else
 if F_COP = 'SCANROOTD' then
 begin

  //extremFunc(MX,E);
  Roots(_FuncDiffRoots,MX,E);
  ShowRoots(MX,E,E);
  {
  L:=Length(MX);
  if (E = 0)  then
  begin
   L:=Length(MX)-1;
   Form1.LeRS:=L;
   if L >= 0 then
   begin
     for i:=1 to L do
     begin
      Form1.R_Xs[i-1]:=MX[i];
     end;
     Form1.CopyToRSD;
     Form1.StS.Caption:='Xs:'+IntToStr(L);
     //Form1.LeRS:=L;
     Form1.cRS:=0;
     if (L > UMHCFS.DRS)then E:=2;
   end;
  end
  else
  E:=1;
 }

 end
 else
 if F_COP = 'SCANROOTD_excess' then
 begin
  
  //excessFunc(MX,E);
  Roots(_FuncExcessRoots,MX,E);
  ShowRoots(MX,E,E);
  {
  L:=Length(MX);
  if (E = 0)  then
  begin
   L:=Length(MX)-1;
   Form1.LeRS:=L;
   if L >= 0 then
   begin
     for i:=1 to L do
     begin
      Form1.R_Xs[i-1]:=MX[i];
     end;
     Form1.CopyToRSD;
     Form1.StS.Caption:='Xs:'+IntToStr(L);
     //Form1.LeRS:=L;
     Form1.cRS:=0;
     if (L > UMHCFS.DRS)then E:=2;
   end;
  end
  else
  E:=1;
  }

 end
 else
 if F_COP = 'SCANROOTD_excessd' then
 begin

  //excessFuncD(MX,E);
   Roots(_FuncExcessDiffRoots,MX,E);
  ShowRoots(MX,E,E);
  {
  L:=Length(MX);
  if (E = 0) then
  begin
   L:=Length(MX)-1;
   Form1.LeRS:=L;
   if L >= 0 then
   begin
     for i:=1 to L do
     begin
      Form1.R_Xs[i-1]:=MX[i];
     end;
     Form1.CopyToRSD;
     Form1.StS.Caption:='Xs:'+IntToStr(L);
     //Form1.LeRS:=L;
     Form1.cRS:=0;
     if (L > UMHCFS.DRS)then E:=2;
   end;
  end
  else
  E:=1;
  }

 end
 else
 if F_COP = 'SCANROOTD_conv' then
 begin
  convFunc(MX,E);
  ShowRoots(MX,E,E);
  {
  L:=Length(MX);
  if (E = 0) then
  begin
   L:=Length(MX);
   Form1.LeRS:=L;
   if L > 0 then
   begin
     for i:=0 to L-1 do
     begin
      Form1.R_Xs[i]:=MX[i];
     end;
     Form1.CopyToRSD;
     Form1.StS.Caption:='Xs:'+IntToStr(L);
     //Form1.LeRS:=L;
     Form1.cRS:=0;
     if (L > UMHCFS.DRS)then E:=2;
   end;
  end
  else
  E:=1;
  }

 end
 else
 if F_COP = 'SCANROOTD_conc' then
 begin
  concFunc(MX,E);
  ShowRoots(MX,E,E);
  {
  L:=Length(MX);
  if (E = 0)  then
  begin
   L:=Length(MX);
   Form1.LeRS:=L;
   if L > 0 then
   begin
     for i:=0 to L-1 do
     begin
      Form1.R_Xs[i]:=MX[i];
     end;
     Form1.CopyToRSD;
     Form1.StS.Caption:='Xs:'+IntToStr(L);
     //Form1.LeRS:=L;
     Form1.cRS:=0;
     if (L > UMHCFS.DRS)then E:=2;
   end;
  end
  else
  E:=1;
  }

 end
 else
 if F_COP = 'SCANROOTD_max' then
 begin

  convFunc(MX,E);
  //ShowRoots(MX,E);
  Er:=0;
  try
    Form1.V_X:=Form1.F_A;
    f1:=CalcFunc(TAddress(Form1.C_Func));
    Form1.V_X:=Form1.F_B;
    f2:=CalcFunc(TAddress(Form1.C_Func));
    if f1 < f2 then begin max:=Form1.F_B; maxf:=f2; end else begin max:=Form1.F_A; maxf:=f1; end;
   except
     Er:=1;
   end;
   PF:=@Form1.V_X;
   L:=Length(MX);

  if (E = 0) and (Er = 0) then
  begin
   for i:=0 to L-1 do
     begin
      PF^:=MX[i];
      F:=CalcFunc(TAddress(Form1.C_Func));
      if F > maxf then begin max:=MX[i]; maxf:=F; end;
     end;
  end
  else
  E:=1;

  Result:=max;


 end
 else
 if F_COP = 'SCANROOTD_min' then
 begin

  concFunc(MX,E);
  Er:=0;
  try
    Form1.V_X:=Form1.F_A;
    f1:=CalcFunc(TAddress(Form1.C_Func));
    Form1.V_X:=Form1.F_B;
    f2:=CalcFunc(TAddress(Form1.C_Func));
    if f1 > f2 then begin min:=Form1.F_B; minf:=f2; end else begin min:=Form1.F_A; minf:=f1; end;
   except
     Er:=1;
   end;
   PF:=@Form1.V_X;
   L:=Length(MX);

  if (E = 0) and (Er = 0) then
  begin
   for i:=0 to L-1 do
     begin
      PF^:=MX[i];
      F:=CalcFunc(TAddress(Form1.C_Func));
      if F < minf then begin min:=MX[i]; minf:=F; end;
     end;
  end
  else
  E:=1;

  Result:=min;

 end
 else
 if F_COP = 'INTEGRAL1F'   then
 begin
   x1:=Form1.Calc(Form1.C_Func1);
   x2:=Form1.Calc(Form1.C_Func2);
   Result:=MathProc.Integral1(TAddress(Form1.C_Func),@Form1.V_X,x1,x2)
 end
 else
 if F_COP = 'INTEGRALN'   then
 begin

   if (Form1.F_E > 1) and (Trunc(Form1.F_E) = Form1.F_E) then P_IntegralMulti:=Trunc(Form1.F_E);
   MathProc.SetMode(ml_Integral_Part_Multi,P_IntegralMulti);
   Form1.P_IntegralMulti:=P_IntegralMulti;

   N:=Length(Form1.D_Xs);
   if (N < 1) or (N > Length(Form1.D_Ys)) or (N > Form1.G_NumberVars)   then
   begin
     E:=4;
   end
   else
   begin
     SetLength(PV,N);
     for i := 0 to N - 1 do
     begin
         //PV[i]:=@Form1.V_YM[i];
         PV[i]:=@Form1.IntListVar[i].FloatVar;
     end;
     Result:=MathProc.IntegralN(N,Form1.D_Xs,Form1.D_Ys,PV,TAddress(Form1.C_Func));
   end;

   Form1.RestoreSavedVarParam;
 end
 else

 if F_COP = 'INTEGRALNF'   then
 begin

   if (Form1.F_E > 1) and (Trunc(Form1.F_E) = Form1.F_E) then P_IntegralMulti:=Trunc(Form1.F_E);
   MathProc.SetMode(ml_Integral_Part_Multi,P_IntegralMulti);
   Form1.P_IntegralMulti:=P_IntegralMulti;

   N:=(Form1.LeFS-1) div 2;
   if (N < 2) or (N > Form1.G_NumberVars) then
   begin
     E:=4;
   end
   else
   begin
     SetLength(PV,N);
     SetLength(FuncN,2*N);
     for i := 0 to N - 1 do
     begin
       //PV[i]:=@Form1.V_YM[i];
        PV[i]:=@Form1.IntListVar[i].FloatVar;
     end;
     for i := 0 to 2*N-1 do
     begin
         Form1.ComplFunc(Form1.F_S[i+1],HCF,Er);
         if Er <> 0 then Etr:=1;
         FuncN[i]:=TAddress(HCF);
     end;

     //Form1.V_YM[0]:=Form1.V_X;
     if Etr = 0 then Result:=MathProc.IntegralNF(N,FuncN,PV,TAddress(Form1.C_Func));
     for i := 0 to 2*N - 1 do
     begin
       Form1.FreeFunc(FuncN[i]);
     end;

   end;

   Form1.RestoreSavedVarParam;
 end

 else
  if F_COP = 'ROOTD1'       then
  begin
    MathProc.SetMode(ml_Root_Derivative1,0);
    Result:=MathProc.Root(TAddress(Form1.C_Func),@Form1.V_X,Form1.V_X,E);
    MathProc.SetMode(ml_Root_Function,0);
    E:=0;
  end

 else
 if F_COP = 'SUMNF'   then
 begin


   //   
   N:=Form1.LeFS-1;
   Nx:=(N-1) div 2;
   if (N < 2) or (Nx > Form1.G_NumberVars)  then
   begin
     E:=4;
   end
   else
   begin

     BH:=False;
     SetLength(AI,N div 2); SetLength(BI,N div 2);  m1:=0; m2:=0;
     for i := 1 to N do
     begin
       try
         Sh:=Form1.F_S[i];
         K:=Pos('.',Sh);
         if K <> 0 then begin Delete(Sh,K,1); Insert(',',Sh,K); end;
         sf:=StrToFloat(Sh);
         if Frac(i/2) = 0 then  begin BI[m1]:=Trunc(sf); inc(m1); end else begin AI[m2]:=Trunc(sf); inc(m2); end;
       except
         BH:=True;
       end;
     end;

     if BH = False then  // 
     begin
       N:=N div 2;
       SetLength(IV,N);
       for i := 0 to N - 1 do
       begin
         //IV[i]:=@Form1.V_IM[i];
         IV[i]:=@Form1.IntListVar[i].IntVar;
       end;
       Result:=MathProc.SumN(N,AI,BI,IV,TAddress(Form1.C_Func));
     end
     else
     begin
       N:=(Form1.LeFS-1) div 2;
       SetLength(IV,N);
       SetLength(FuncN,2*N);
       for i := 0 to N - 1 do
       begin
         //IV[i]:=@Form1.V_IM[i];
         IV[i]:=@Form1.IntListVar[i].IntVar;
       end;
       for i := 0 to 2*N-1 do
       begin
         Form1.ComplFunc(Form1.F_S[i+1],HCF,Er);
         if Er <> 0 then Etr:=1;
         FuncN[i]:=TAddress(HCF);
       end;
       //Form1.V_YM[0]:=Form1.V_X;
       if Etr = 0 then Result:=MathProc.SumNF(N,FuncN,IV,TAddress(Form1.C_Func));
       for i := 0 to 2*N - 1 do
       begin
         Form1.FreeFunc(FuncN[i]);
       end;
     end;

   end;

   Form1.RestoreSavedVarParam;
 end

 else
 if F_COP = 'MULNF'   then
 begin
   //   
   N:=Form1.LeFS-1;
   Nx:=(N-1) div 2;
   if (N < 2) or (Nx > Form1.G_NumberVars) then
   begin
     E:=4;
   end
   else
   begin

      BH:=False;
      SetLength(AI,N div 2); SetLength(BI,N div 2);  m1:=0; m2:=0;
      for i := 1 to N do
      begin
        try
          Sh:=Form1.F_S[i];
          K:=Pos('.',Sh);
          if K <> 0 then begin Delete(Sh,K,1); Insert(',',Sh,K); end;
          sf:=StrToFloat(Sh);
          if Frac(i/2) = 0 then  begin BI[m1]:=Trunc(sf); inc(m1); end else begin AI[m2]:=Trunc(sf); inc(m2); end;
        except
          BH:=True;
        end;
      end;

      if BH = False then  // 
      begin
        N:=N div 2;
        SetLength(IV,N);
        for i := 0 to N - 1 do
        begin
          IV[i]:=@Form1.V_IM[i];
        end;
        Result:=MathProc.MulN(N,AI,BI,IV,TAddress(Form1.C_Func));
      end
      else
      begin
        N:=(Form1.LeFS-1) div 2;
        SetLength(IV,N);
        SetLength(FuncN,2*N);
        for i := 0 to N - 1 do
        begin
          IV[i]:=@Form1.V_IM[i];
        end;
        for i := 0 to 2*N-1 do
        begin
          Form1.ComplFunc(Form1.F_S[i+1],HCF,Er);
          if Er <> 0 then Etr:=1;
          FuncN[i]:=TAddress(HCF);
        end;
        //Form1.V_YM[0]:=Form1.V_X;
        if Etr = 0 then Result:=MathProc.MULNF(N,FuncN,IV,TAddress(Form1.C_Func));
        for i := 0 to 2*N - 1 do
        begin
          Form1.FreeFunc(FuncN[i]);
        end;
      end;

   end;

   Form1.RestoreSavedVarParam;
 end;


 except
  Error:=True;
  Form1.RestoreSavedVarParam;
 end;

 if Etr = 1 then goto endp;

 if E = 1 then Error:=True;
 if Error = True then
 begin
  Form1.STV.Font.Color:=clAqua; Form1.ERROR;
 end
 else
 begin
   if E = 2 then
   begin
      Form1.STV.Font.Color:=clAqua;
      Form1.STV.Caption:='NUMBERS IN Xs MORE 999';
   end
   else
   if E = 3 then
   begin
      Form1.STV.Font.Color:=clAqua;
      Form1.STV.Caption:='NOT FOUND';
   end
   else
   if E = 4 then
   begin
      Form1.STV.Font.Color:=clAqua;
      Form1.STV.Caption:='WRONG DATA SET';
   end
   else
   begin
     Form1.STV.Font.Color:=clAqua;
     Form1.V_X:=Result;
     Form1.OutVar(Result);
     if I_reg = 'x' then
     begin
      Form1.R_X:=Result; Form1.reg:= 'x';
     end
     else  Form1.R_Y:=Result;
   end;
 end;

 Form1.OutStack;

endp:
 Form1.FTF:=False;
 Form1.STFunc.Caption:='  ';
end;




end.
